// Code generated by "enumer -type=DbStatus -json -text -yaml -sql"; DO NOT EDIT.

//
package dbStatus

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _DbStatusName = "NANotFoundNoValueOK"

var _DbStatusIndex = [...]uint8{0, 2, 10, 17, 19}

func (i DbStatus) String() string {
	if i < 0 || i >= DbStatus(len(_DbStatusIndex)-1) {
		return fmt.Sprintf("DbStatus(%d)", i)
	}
	return _DbStatusName[_DbStatusIndex[i]:_DbStatusIndex[i+1]]
}

var _DbStatusValues = []DbStatus{0, 1, 2, 3}

var _DbStatusNameToValueMap = map[string]DbStatus{
	_DbStatusName[0:2]:   0,
	_DbStatusName[2:10]:  1,
	_DbStatusName[10:17]: 2,
	_DbStatusName[17:19]: 3,
}

// DbStatusString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func DbStatusString(s string) (DbStatus, error) {
	if val, ok := _DbStatusNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to DbStatus values", s)
}

// DbStatusValues returns all values of the enum
func DbStatusValues() []DbStatus {
	return _DbStatusValues
}

// IsADbStatus returns "true" if the value is listed in the enum definition. "false" otherwise
func (i DbStatus) IsADbStatus() bool {
	for _, v := range _DbStatusValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for DbStatus
func (i DbStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for DbStatus
func (i *DbStatus) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("DbStatus should be a string, got %s", data)
	}

	var err error
	*i, err = DbStatusString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for DbStatus
func (i DbStatus) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for DbStatus
func (i *DbStatus) UnmarshalText(text []byte) error {
	var err error
	*i, err = DbStatusString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for DbStatus
func (i DbStatus) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for DbStatus
func (i *DbStatus) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = DbStatusString(s)
	return err
}

func (i DbStatus) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *DbStatus) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := DbStatusString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
